#-*- coding: UTF-8 -*-

#**********************************************
# R2spec 
#
# Class file for the class Noarch
#
# Distributed under License GPLv3 or later
# You can find a copy of this license on the website
# http://www.gnu.org/licenses/gpl.html
#
#**********************************************

import os
from Spec import *

class Noarch(Spec):
    """
    Noarch Class
        Write the spec file for noarch package.
    """
    
    def __init__(self, package):
        self.package = package
    
    def writeSpec(self):
        ''' Write the spec file '''
        if self.package.packager.name == None : 
            self.package.packager.name = 'Name'
        if self.package.packager.email == None : 
            self.package.packager.email = 'Mail'
        if self.package.source0 == None : 
            self.package.source0 = ''
        if self.package.URL == None : 
            self.package.URL = ''

        print "\n","*"*50,"\n Generate the spec file\n"
        specname = "R-" + self.package.name + ".spec"
        if specname in os.listdir('./'):
            text =  "The specfile R-" + self.package.name + ".spec already exist !\nDo you want to overwrite it ? Y/N [N]\n"
            answer = raw_input(text)
            if answer == '':
                answer = "N"
            if answer.lower() == "n" or answer.lower() == "no":
                if specname+"-new" not in os.listdir('./'):
                    specname = specname+"-new"
                elif specname+"-new1" not in os.listdir('./'):
                    specname = specname+"-new1"
                else:
                    text = "There are already several version of the specfile in this directory, please indiquate the name you would like to give:\n"
                    specname = raw_input(text)
        
        print os.getcwd(), specname
        specfile = open(specname, 'w')
        spec = ""
        if self.package.packager.bioc:
            spec += "%define BioC      " + self.package.packager.bioc + "\n"
        spec += """%define packname  """ + self.package.name + """

Name:             R-%{packname}
Version:          """ + self.package.description.version + """
Release:          1%{?dist}
Summary:          <      summary should be not be longer than that       >

Group:            Applications/Engineering 
License:          """ + self.package.description.license + """ 
URL:              """ + self.package.URL + """
Source0:          """ + self.package.source0 + """
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:        noarch

Requires:         """ + self.package.description.depends + " " + self.package.description.suggests + """
Requires(post):   R
Requires(postun): R
BuildRequires:    R-devel tetex-latex """ + self.package.description.depends + " " + self.package.description.suggests + """

%description
""" + self.package.description.description + """

%prep
%setup -q -c -n %{packname}

%build

%install
rm -rf %{buildroot}


#i368 arch
#mkdir -p %{buildroot}%{_libdir}/R/library 
#R CMD INSTALL %{packname} -l %{buildroot}%{_libdir}/R/library
## Clean up in advance of check
#test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
#rm -rf %{buildroot}%{_libdir}/R/library/R.css

#noarch
mkdir -p %{buildroot}%{_datadir}/R/library 
R CMD INSTALL %{packname} -l %{buildroot}%{_datadir}/R/library
# Clean up in advance of check
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -rf %{buildroot}%{_datadir}/R/library/R.css

%check
%{_bindir}/R CMD check %{packname}

%clean
rm -rf %{buildroot}

%post
%{_R_make_search_index}

%postun
%{_R_make_search_index}

%files
%defattr(-, root, root, -)
#i386 arch
#%dir %{_libdir}/R/library/%{packname}
#%doc %{_libdir}/R/library/%{packname}/latex
#%doc %{_libdir}/R/library/%{packname}/doc
#%doc %{_libdir}/R/library/%{packname}/html
#%doc %{_libdir}/R/library/%{packname}/DESCRIPTION
#%doc %{_libdir}/R/library/%{packname}/man
#%doc %{_libdir}/R/library/%{packname}/NEWS

#noarch
%dir %{_datadir}/R/library/%{packname}
%doc %{_datadir}/R/library/%{packname}/latex
%doc %{_datadir}/R/library/%{packname}/doc
%doc %{_datadir}/R/library/%{packname}/html
%doc %{_datadir}/R/library/%{packname}/DESCRIPTION
%doc %{_datadir}/R/library/%{packname}/man
%doc %{_datadir}/R/library/%{packname}/NEWS
%{_datadir}/R/library/%{packname}/CONTENTS
%{_datadir}/R/library/%{packname}/INDEX
%{_datadir}/R/library/%{packname}/NAMESPACE
%{_datadir}/R/library/%{packname}/Meta
%{_datadir}/R/library/%{packname}/R
%{_datadir}/R/library/%{packname}/R-ex
%{_datadir}/R/library/%{packname}/help

%changelog
* """ + self.package.date + " " + self.package.packager.name + " <" + self.package.packager.email + "> " + self.package.description.version + """-1
- initial package for Fedora
"""
        specfile.write(spec)
        specfile.close()
    
    def writeOut(self):
        print """Done
TODO:
 * Add Summary
 * Add/Check description
 * Check license
 * Add/Check Source0 and URL
 * Check Arch - We detected it as Noarch package but it needs to be checked
 * Change Requires and BuildRequires
 * Change %files
"""

